<template>
  <div class="sw-gs-widget-area">
    <SfAccordion transition="false" showChevron>
      <SwPluginSlot name="gs-layer-widgets-before"></SwPluginSlot>

      <SwGsAccordionItem :header="$t('Notes')"
                         :badge="notesCount"
                         badge-variant="light"
                         :hideEmptyBadge="notesCount  === '0'"
                         class="gs-widget-notes-accordion">
        <template #icon>
          <SwGsIconNotes class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <SwPluginSlot name="gs-widget-notes"/>
      </SwGsAccordionItem>

      <SwGsAccordionItem v-if="!isSelfService"
                         :header="$t('Cart insights')"
                         :badge="cartItemCount"
                         :hideEmptyBadge="cartItemCount  === '0'"
                         :textRight="formatPrice(cartTotalPrice, {separator: '.'})"
                         class="gs-widget-cart-insights-accordion">
        <template #icon>
          <SwGsIconPieChart class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <SwPluginSlot name="gs-widget-cart-insights"/>
      </SwGsAccordionItem>

      <SwGsAccordionItem :header="$t('Customer insights')"
                         :badge="clientsCount"
                         class="gs-widget-customer-insights-accordion">
        <template #icon>
          <SwGsIconClients class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <SwPluginSlot name="gs-widget-customer-insights"/>
      </SwGsAccordionItem>

      <SwGsAccordionItem v-if="product"
                         :header="$t('Product insights')"
                         class="gs-widget-product-insights-accordion">
        <template #icon>
          <SwGsIconInfo class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <SwPluginSlot name="gs-widget-product-insights" :slotContext="product" :key="product.id"/>
      </SwGsAccordionItem>

      <SwGsAccordionItem v-if="product"
                         :header="$t('Product variants')"
                         :badge="productVariantsCount"
                         :hideEmptyBadge="productVariantsCount === '0'"
                         class="gs-widget-product-variants-accordion">
        <template #icon>
          <SwGsIconProductVariants class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <SwPluginSlot name="gs-widget-product-variants" :slotContext="product"/>
      </SwGsAccordionItem>

      <SwGsAccordionItem v-if="product"
                         :header="$t('Cross selling')"
                         :badge="crossSellCount"
                         :hideEmptyBadge="crossSellCount === '0'"
                         class="gs-widget-crossselling-accordion">
        <template #icon>
          <SwGsIconCrossselling class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <SwPluginSlot name="gs-widget-crossselling" :slotContext="product"/>
      </SwGsAccordionItem>

      <SwGsAccordionItem :header="$t('Instant listing')"
                         ref="instantListingAccordion"
                         class="gs-widget-instant-listing-accordion"
                         :disabled="!showInstantListing"
                         @toggleItem="toggleInstantListingAccordion"
      >
        <template #header >

        </template>
        <template #icon>
          <SwGsIconListing class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <template #badge>
          <div class="sf-accordion-item__badge" v-if="showInstantListing">
            <SwButton class="sw-gs-create-bn is-circle" :class="{'color-light': !isIlCreationMode, 'color-primary': isIlCreationMode}"
                      :title="$t('Create New Listing at Slide')"
                      @click="createNewInstantListingAccordion">
              <SwGsIconPlus class="size-xs"></SwGsIconPlus>
            </SwButton>
            <SwButton v-if="isProductListing"
                      class="sw-gs-edit-btn is-circle" :class="{'color-light': !isIlEditMode, 'color-primary': isIlEditMode}"
                      :title="$t('Edit')"
                      @click="editInstantListingAccordion">
              <SwGsIconEdit class="size-xs"></SwGsIconEdit>
            </SwButton>
          </div>
        </template>

        <SwPluginSlot name="gs-widget-instant-listing"/>
      </SwGsAccordionItem>

      <SwGsAccordionItem :header="$t('Guide product list')"
                         ref="guideProductListAccordion"
                         :hideEmptyBadge="guideLikeList.length === 0"
                         @toggleItem="toggleGuidedProductListingAccordion"
                         class="gs-widget-guide-product-list-accordion">
        <template #icon>
          <SwGsIconBookmarkOn class="color-dark-secondary size-sm sf-accordion-item__icon"/>
        </template>

        <template #badge>
          <SfBadge v-if="guideLikeList.length" class="sf-badge--number color-primary">
            {{ guideLikeList.length }}
          </SfBadge>
          <div class="sf-accordion-item__badge">
            <SwButton class="sw-gs-create-bn is-circle"
                      :class="guideProductPlusBtnClass"
                      @click="openGuideProductListing">
              <SwGsIconPlus class="size-xs"></SwGsIconPlus>
            </SwButton>
          </div>
        </template>

        <SwPluginSlot name="gs-widget-guide-product-list"/>
      </SwGsAccordionItem>

      <SwPluginSlot name="gs-layer-widgets-after"></SwPluginSlot>
    </SfAccordion>
  </div>
</template>

<script lang="ts">
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import SwGsAccordionItem from "./SwGsAccordionItem.vue";
  import {SfAccordion, SfBadge} from "@storefront-ui/vue";
  import {computed, watch, ref, onMounted, onBeforeUnmount} from "@vue/composition-api";
  import {debounce} from "lodash";
  import {usePresentation} from "../../logic/composables/usePresentation";
  import {useAppointment} from "../../logic/composables/useAppointment";
  import {useState} from "../../logic/composables/useState";
  import {useCartInsights} from "../../logic/composables/widgets/useCartInsights";
  import {useCrossSelling} from "../../logic/composables/widgets/useCrossSelling";
  import {useNotes} from "../../logic/composables/widgets/useNotes";
  import {useLikeList} from "../../logic/composables/useLikeList";
  import {useProductVariants} from "../../logic/composables/widgets/useProductVariants";
  import {useInstantListing, INSTANT_LISTING_TYPES} from "../../logic/composables/useInstantListing";
  import {usePriceFilter} from "../../logic/composables/usePriceFilter";
  import SwButton from "@/components/atoms/SwButton.vue";
  import {
    SwGsIconBookmarkOn,
    SwGsIconClients,
    SwGsIconCrossselling,
    SwGsIconEdit,
    SwGsIconInfo,
    SwGsIconListing,
    SwGsIconNotes,
    SwGsIconPieChart,
    SwGsIconPlus,
    SwGsIconProductVariants
  } from "../icons";

  const RESIZE_DEBOUNCE_TIME = 300;

  export default {
    name: "SwGsLayerWidgets",
    components: {
      SwPluginSlot,
      SwGsAccordionItem,
      SfAccordion,
      SfBadge,
      SwGsIconCrossselling,
      SwGsIconListing,
      SwGsIconBookmarkOn,
      SwGsIconProductVariants,
      SwGsIconInfo,
      SwGsIconClients,
      SwGsIconPieChart,
      SwGsIconNotes,
      SwButton,
      SwGsIconPlus,
      SwGsIconEdit
    },
    setup() {
      const product = computed(() => currentPageResponse.value?.product);
      const { formatPrice } = usePriceFilter();
      const {currentPageResponse, currentSlideIndex, isProductListing} = usePresentation();
      const {isSelfService} = useAppointment();
      const {cartSum, productCount, loadCartInsights} = useCartInsights();
      const {crossSellCount} = useCrossSelling(product.value);
      const {productVariantsCount} = useProductVariants(product.value);
      const {clients} = useState();
      const {guideLikeList} = useLikeList();
      const {notesCount} = useNotes();
      const {createNewInstantListing, clearSessionStorageData, editInstantListing, isCreationMode, isEditMode, closeInstantListing, isInstantListingModalOpen, instantListingModalType, instantListingAccordion, openInstantListing} = useInstantListing();

      const showInstantListing = ref<boolean>(false);
      const guideProductListAccordion = ref<any>(null);

      loadCartInsights();

      const createNewInstantListingAccordion = (e) => {
        e.stopPropagation();
        clearSessionStorageData();
        createNewInstantListing();
        if (!instantListingAccordion.value.isOpen) instantListingAccordion.value.accordionClick({'stopPropagation': true});
      }
      const editInstantListingAccordion = (e) => {
        e.stopPropagation();
        if (!isEditMode.value) {
          clearSessionStorageData();
          editInstantListing();
        }
        if (!instantListingAccordion.value.isOpen) instantListingAccordion.value.accordionClick({'stopPropagation': true});
      }
      const openGuideProductListing = (e) => {
        e.stopPropagation();
        openInstantListing('', INSTANT_LISTING_TYPES[1]);
        if (!guideProductListAccordion.value.isOpen) guideProductListAccordion.value.accordionClick({'stopPropagation': true});
      }

      const toggleListing = (shouldOpen, options, type) => {
        if (options && options.stopPropagation) return;
        if (!shouldOpen) {
          closeInstantListing();
        } else {
          openInstantListing(options?.mode, type);
        }
      }

      const toggleInstantListingAccordion = (shouldOpen, options) => {
        if (shouldOpen === isInstantListingModalOpen.value && instantListingModalType.value === INSTANT_LISTING_TYPES[0]) return;
        toggleListing(shouldOpen, options, INSTANT_LISTING_TYPES[0]);
      }

      const toggleGuidedProductListingAccordion = (shouldOpen, options) => {
        if (shouldOpen === isInstantListingModalOpen.value && instantListingModalType.value === INSTANT_LISTING_TYPES[1]) return;
        toggleListing(shouldOpen, options, INSTANT_LISTING_TYPES[1]);
      }

      const resizeHandler = debounce(() => {
        if (window.innerWidth >= 1024) {
          showInstantListing.value = true;
        } else {
          showInstantListing.value = false;
          isInstantListingModalOpen.value = false;
        }
      }, RESIZE_DEBOUNCE_TIME); // the delay is needed since it takes a moment for the rotation to update the content width.

      onMounted(() => {
        resizeHandler();
        window.addEventListener("resize", resizeHandler);
      });

      watch(isInstantListingModalOpen, (shouldOpen) => {
        if (instantListingModalType.value === INSTANT_LISTING_TYPES[0]) {
          if (shouldOpen && !instantListingAccordion.value.isOpen) {
            instantListingAccordion.value.open();
          } else if (!shouldOpen && instantListingAccordion.value.isOpen) {
            instantListingAccordion.value.close();
          }
        } else if (instantListingModalType.value === INSTANT_LISTING_TYPES[1]) {
          if (shouldOpen && !guideProductListAccordion.value.isOpen) {
            guideProductListAccordion.value.open();
          } else if (!shouldOpen && guideProductListAccordion.value.isOpen) {
            guideProductListAccordion.value.close();
          }
        } else {
          if (!shouldOpen) {
            instantListingAccordion.value.close();
            guideProductListAccordion.value.close();
          }
        }
      });

      onBeforeUnmount(() => {
        window.removeEventListener("resize", resizeHandler);
      });

      return {
        product,
        cartItemCount: computed(() => productCount.value.toString()),
        showInstantListing: computed(() => showInstantListing.value),
        cartTotalPrice: cartSum,
        formatPrice,
        productVariantsCount: computed(() => productVariantsCount.value ? productVariantsCount.value.toString() : '0'),
        crossSellCount: computed(() => crossSellCount.value ? crossSellCount.value.toString() : '0'),
        clients,
        clientsCount: computed(() => clients.value ? clients.value.length.toString() : '0'),
        guideProductPlusBtnClass: computed(() => isInstantListingModalOpen && instantListingModalType.value === INSTANT_LISTING_TYPES[1] ? 'color-primary' : 'color-light'),
        isSelfService,
        guideLikeList,
        notesCount,
        toggleListing,
        isProductListing,
        createNewInstantListingAccordion,
        editInstantListingAccordion,
        toggleInstantListingAccordion,
        toggleGuidedProductListingAccordion,
        isIlCreationMode: isCreationMode,
        isIlEditMode: isEditMode,
        guideProductListAccordion,
        openGuideProductListing,
        instantListingAccordion
      }
    }

  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-widget-area {
    padding: 0 var(--spacer-sm) var(--spacer-sm);
  }

  .gs-widget-instant-listing-accordion,
  .gs-widget-guide-product-list-accordion {

    .sf-accordion-item__badge {
      display: flex;

      button {
        margin: -10px 0 -10px var(--spacer-sm);

        &.sf-button.is-circle {
          padding: 8px;
        }
      }
    }
  }

  .gs-widget-crossselling-accordion {
    ::v-deep .sf-accordion-item__content {
      padding-top: 0;
    }
  }

  .sf-accordion-item {
    border-bottom: 1px solid var(--_c-gray-accent);

    > ::v-deep {
      .sf-accordion-item__header {
        border-bottom: none;
      }
    }
  }

  ::v-deep .sf-accordion-item__content {
    border-top: none;
    padding: var(--spacer-xs);

    .sf-accordion-item__text {
      font-size: var(--font-size--sm);
    }

    .sf-accordion-item__content {
      padding-left: 0;
      padding-right: 0;
    }

    .sf-accordion-item__chevron {
      height: var(--icon-xs-size);
      width: var(--icon-xs-size);
    }
  }
</style>
